#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#define MAX_PREM 5500L // Pas plus de 5500 (taille du heap)

extern int  *Nb_PeriodeEntiere;	// La priode complte (tableau de [MAX_PREM+50L])
extern int  *Nb_Periode;			// La priode (tableau de [MAX_PREM+50L])
extern long Nb_LongPeriode;		// La longueur de la priode

// Avec ca en reserve, les fonctions peuvent tester jusqu'a 1153 au carre
int Premier[200]={
2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,
53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,
127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,
199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,
283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,
383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,
467,479,487,491,499,503,509,521,523,541,547,557,563,569,571,
577,587,593,599,601,607,613,617,619,631,641,643,647,653,659,
661,673,677,683,691,701,709,719,727,733,739,743,751,757,761,
769,773,787,797,809,811,821,823,827,829,839,853,857,859,863,
877,881,883,887,907,911,919,929,937,941,947,953,967,971,977,
983,991,997,1009,1013,1019,1021,1031,1033,1039,1049,1051,1061,1063,1069,
1087,1091,1093,1097,1103,1109,1117,1123,1129,1151,1153};



long of_getperiode (long pl_premier, long pl_base);// Mefiance avec les non-premiers
long of_getinverse (long pl_premier, long pl_base);
long of_getgraine (long pl_premier);
long of_getpgcd (long pl_a, long pl_b);
long of_getPuissance (long pl_premier,long pl_Graine,long pl_Base);
long of_getNbBase (long pl_premier);
long of_getpremdiv (long pl_candidat);
static char *of_getdiv (long pl_candidat);
long of_getpremproche (long pl_candidat, long pl_inc);
long of_getperiodeNb (long pl_nombre, long pl_base, long pl_Dividende);
long of_getprembaseproche (long pl_premier, long pl_basecandidat, long pl_inc);
long of_getprempetitebaseproche (long pl_premier, long pl_basecandidat, long pl_inc);
long of_gettotalperiode(long pl_premier, long pl_base);

//==============================================================================================
long of_getpremproche (long pl_candidat, long pl_inc)
{
static 	long  ll_Ret;

	if (pl_candidat<=2L && pl_inc<0L) return 2L;

	if (pl_candidat >= MAX_PREM && pl_inc>0L)
		{
		ll_Ret = pl_candidat;
		while ((of_getpremdiv(ll_Ret)!=ll_Ret) && (pl_candidat > MAX_PREM)) ll_Ret--;
		}
	else
		{
		ll_Ret = pl_candidat;
		while (of_getpremdiv(ll_Ret)!=ll_Ret) ll_Ret+=pl_inc;
		}

	return ll_Ret;
}


//==============================================================================================
long of_getprembaseproche (long pl_premier, long pl_basecandidat, long pl_inc)
{
	static long  ll_Ret;

	ll_Ret = pl_basecandidat%pl_premier;

	while (of_getperiode(pl_premier, ll_Ret)!=pl_premier-1L)
	{
	ll_Ret = (ll_Ret + pl_inc + pl_premier) % pl_premier;
	}
	return ll_Ret;
}

//==============================================================================================
long of_getprempetitebaseproche (long pl_premier, long pl_basecandidat, long pl_inc)
{
	static long	ll_Ret;
	int			li_Sortie;
	long		ll_Inverse;

	li_Sortie =0;
	ll_Ret = (pl_basecandidat+pl_premier)%pl_premier;

	while (!li_Sortie)
	{
	if (of_getperiode(pl_premier, ll_Ret)==(pl_premier-1L))
		{
		ll_Inverse = of_getinverse (pl_premier, ll_Ret);
		if (ll_Inverse >= ll_Ret)
			li_Sortie = 1;
		}
	if (!li_Sortie) ll_Ret = (ll_Ret + pl_inc + pl_premier) % pl_premier;
	}
	return ll_Ret;
}
//==============================================================================================
//==============================================================================================
long of_getinverse(long pl_premier, long pl_base)
{
long		ll_premier;
long		ll_base;
static long		ll_Result;
long		ll_Inverse;

// Les cas triviaux 0 et 1 sont limins.
ll_Result = pl_base%pl_premier;
if (ll_Result==0L || ll_Result==1L)
	return ll_Result;

// On commence le calcul,
ll_Result = 1L;
ll_premier = pl_premier;
ll_base = pl_base;
ll_Inverse = ll_base;

do
{
	ll_Result = ll_Result + 1L;	// A partir de 2
	ll_Inverse = (ll_Inverse + ll_base)%ll_premier;
}
while (ll_Inverse != 1L && ll_Result < pl_premier);	// Jusqu'au premier.

if (ll_Inverse == 1L)	// Si on a trouv un inverse
	return ll_Result;	// On renvoie la base
else
	return 0L;
}

//==============================================================================================
long of_getgraine(long pl_premier)
{

static long		ll_Base;
long		ll_Per;

ll_Base = 1L;

do
{
	ll_Base = ll_Base + 1L;		// On commence en base 2
	ll_Per = of_getperiode(pl_premier, ll_Base);
}
while (ll_Per != pl_premier - 1L);

return ll_Base;
}

//==============================================================================================
long of_getpgcd(long pl_a, long pl_b)
{
static long	ll_a;
long	ll_b;
long	ll_r;

ll_a = pl_a;
ll_b = pl_b;

/*
// Par securite
if (ll_a < ll_b)	// si b est plus grand que a, on change les deux valeurs.
    {
	ll_r = ll_a;
	ll_a = ll_b;
	ll_b = ll_r;
    }
*/

while (ll_b > 0L)
    {
	ll_r = ll_a%ll_b;
	ll_a = ll_b;
	ll_b = ll_r;
    };

return ll_a;
}
//==============================================================================================
long of_getPuissance(long pl_premier,long pl_Graine,long pl_Base)
{
static 	long   ll_Ret;
	long   ll_BaseTest;

    ll_Ret = 0;
    ll_BaseTest = 1L;
	do
	{
     ll_BaseTest = (ll_BaseTest * pl_Graine)%pl_premier;
     ll_Ret++;
	}
	while(ll_BaseTest!=pl_Base);
return ll_Ret;
}

//==============================================================================================
long of_getNbBase(long pl_premier)
{

   long  ll_i;
static    long  ll_Ret;

   ll_Ret=0L;
   pl_premier--;

   for (ll_i=1L;ll_i<pl_premier;ll_i++)
       {
        if (of_getpgcd (pl_premier, ll_i)==1L)
		   ll_Ret++;
	   }

return ll_Ret;
}

//==============================================================================================
long of_getpremdiv(long pl_candidat)
{
long  ll_Limite;
static long  ll_Ret;
long  ll_Cpt;
long  ll_Test;

ll_Limite = long(sqrt(pl_candidat)) + 1L;
ll_Cpt = 0L;
do
{
	ll_Test = Premier[ll_Cpt];
	ll_Cpt++;
	if (pl_candidat%ll_Test == 0L)	// Le nombre est compos, on renvoi son premier diviseur
		ll_Ret = ll_Test;
	else

	if (ll_Test > ll_Limite)		// Le nombre est premier, on renvoi le candidat
		ll_Ret = pl_candidat;
}
while ((pl_candidat%ll_Test != 0L) && (ll_Test <= ll_Limite));

return ll_Ret;
}

//==============================================================================================
char *of_getdiv(long pl_candidat)
{
long  ll_Diviseur;
long  ll_MemDiviseur;
long  ll_i;
long  ll_Reste;
long  ll_NbDiv;
long  ll_div[20];
long  ll_exp[20];
static char ls_ret[128];
char  ls_temp[16];

ll_NbDiv = 0L;

for (ll_i=0L;ll_i<20L;ll_i++)
    {
	ll_div[ll_i] = 0L;
	ll_exp[ll_i] = 0L;
	}

ll_Reste = pl_candidat;
ll_MemDiviseur = 0L;

do
{
	ll_Diviseur = of_getpremdiv(ll_Reste);
	if (ll_MemDiviseur != ll_Diviseur)
	    {
		ll_NbDiv++;
		ll_MemDiviseur = ll_Diviseur;
		ll_div[ll_NbDiv] = ll_Diviseur;
		ll_exp[ll_NbDiv] = 1L;
	    }
	else
	    {
		ll_div[ll_NbDiv] = ll_Diviseur;
		ll_exp[ll_NbDiv]+=1L;
	    }
	ll_Reste = ll_Reste / ll_Diviseur;
}
while (ll_Reste != 1L);

strcpy(ls_ret, "");

for (ll_i=1L;ll_i<=ll_NbDiv;ll_i++)
   {
	sprintf(ls_temp, "%d", ll_div[ll_i]);
	strcat(ls_ret, ls_temp);
	if (ll_exp[ll_i] != 1L)
	   {
	    sprintf(ls_temp, "^%d", ll_exp[ll_i]);
	    strcat(ls_ret, ls_temp);
	   }
	if (ll_i != ll_NbDiv)
	   {
	    sprintf(ls_temp, "x");
	    strcat(ls_ret, ls_temp);
	   }
   }

return ls_ret;
}

//==============================================================================================
long of_getperiode(long pl_premier, long pl_base)
{
static long		ll_Periode;
long		ll_Dividende;
long		ll_Quotient;
long		ll_Reste;
long		ll_PremReste;
long		ll_Ret;

ll_Periode = 0L;
ll_Dividende = 1L;
ll_Quotient = 0L;

ll_Ret = pl_base%pl_premier;

if (ll_Ret==0L)
	return 0L;

if (ll_Ret==1L)
	pl_base = pl_base + pl_premier;

do
{
	ll_Reste = ll_Dividende - ll_Quotient * pl_premier;
	ll_Dividende = ll_Reste * pl_base;
	ll_Quotient = long(ll_Dividende / pl_premier);
	if (ll_Periode == 0L)
	    ll_PremReste = ll_Reste;
	ll_Periode++;
}
while (ll_Periode == 1L || ll_Reste != ll_PremReste);

return --ll_Periode;
}

//==============================================================================================
long of_getperiodeNb(long pl_nombre, long pl_base, long pl_Dividende)
{
  long  ll_Dividende1;
  long  ll_Dividende2;
  long  ll_Quotient1;
  long  ll_Quotient2;
  long  ll_Reste1;
  long  ll_Reste2;
  long  ll_base1;
  long  ll_base2;
  long  ll_i;
  long  ll_DebFin;

ll_base1 = pl_base%pl_nombre;
if (ll_base1==1) ll_base1 = 1 + pl_nombre;
ll_base2 = ll_base1 + pl_nombre;

ll_Dividende1	= pl_Dividende;
ll_Quotient1	= 0;
ll_Dividende2	= pl_Dividende;
ll_Quotient2	= 0;

for (ll_i = 0L; ll_i < pl_nombre; ll_i++)
	{
	ll_Reste1 = ll_Dividende1 - ll_Quotient1 * pl_nombre;
	ll_Dividende1 = ll_Reste1 * ll_base1;
	ll_Quotient1 = long(ll_Dividende1 / pl_nombre);

	ll_Reste2 = ll_Dividende2 - ll_Quotient2 * pl_nombre;
	ll_Dividende2 = ll_Reste2 * ll_base2;
	ll_Quotient2 = long(ll_Dividende2 / pl_nombre);

	Nb_PeriodeEntiere[ll_i] = (int)(ll_Quotient2 - ll_Quotient1);
	}


Nb_LongPeriode = 0L;
ll_i = pl_nombre - 1;
ll_DebFin  = (long)Nb_PeriodeEntiere[ll_i];
do
{
	ll_i--;
	Nb_LongPeriode++;
}
while(ll_DebFin != (long)Nb_PeriodeEntiere[ll_i]);

for (ll_i = 0L; ll_i <= (long)Nb_LongPeriode; ll_i++)
	Nb_Periode[ll_i] = Nb_PeriodeEntiere[pl_nombre - Nb_LongPeriode + ll_i - 1];

if (Nb_LongPeriode==1 && Nb_PeriodeEntiere[pl_nombre - 1]==0)
	Nb_LongPeriode = 0;

return Nb_LongPeriode;
}

//==============================================================================================
long of_gettotalperiode(long pl_Nb, long pl_Base)
{
	static long	ll_Ret;
	long	ll_PGCD = 0L;

	ll_Ret = pl_Nb;
	while (ll_PGCD != 1L)
		{
		ll_PGCD = of_getpgcd(ll_Ret, pl_Base);
		ll_Ret = ll_Ret/ll_PGCD;
		};
	ll_Ret--;
	return ll_Ret;
}


//==============================================================================================

